// spica javascript libraries - formhandler.js
// == written by Takuya Otani <takuya.otani@gmail.com> ===
// == Copyright (C) 2004 SimpleBoxes/SerendipityNZ Ltd. ==

// [guideline]
// -- http://serennz.sakura.ne.jp/guidelines/js_en_000.txt
// -- http://serennz.sakura.ne.jp/guidelines/js_ja_000.txt

// ver 0.00 [2008/11/01] the first attempt

Spica.FormHandler = function()
{
	this._ignore = true;
	this.initialze();
	return this;
}
Spica.FormHandler.instance = null;
Spica.FormHandler.prototype = {
	initialze : function()
	{
		var self = this;
		var forms = document.getElementsByTagName('form');
		var check = '';
		for (var i=0,n=forms.length;i<n;i++)
		{
			var form = forms[i];
			var elems = form.elements;
			for (var j=0,m=elems.length;j<m;j++)
			{
				var elem = elems[j];
				if (elem.disabled) continue;
				if (elem.type == 'hidden' || elem.type == 'button' || elem.type == 'reset') continue;
				if (elem.type == 'submit' || elem.type == 'image')
				{
					Spica.Event.register(elem,'click',self.get_handler(elem,'click'));
					elem.disabled = false;
				}
				if (elem.className.indexOf('form-control') > -1) continue;
				if (form.className.indexOf('form-control') > -1) continue;
				if (!elem.name || elem.name == '') continue;
				Spica.Event.register(elem,'change',function() { self.setConfirmationToLeave(true); });
			}
			Spica.Event.register(form, 'submit', self.get_handler(form,'submit'));
		}
		var anchor = document.getElementsByTagName('a');
		for (var i=0,n=anchor.length;i<n;i++)
		{
			if (anchor[i].getAttribute('target') && anchor[i].getAttribute('target') != '') continue;
			if (!anchor[i].getAttribute('href') || anchor[i].getAttribute('href') == '#') continue;
			if (anchor[i].getAttribute('onclick') && anchor[i].getAttribute('onclick') != '') continue;
			Spica.Event.register(anchor[i],'click',function(evnt) { self._onleave(evnt); });
		}
	},
	get_handler : function(obj,type)
	{
		var self = this;
		if (!obj) return function() {};
		if (type == 'click')
			return function() { self._onclick(obj); };
		else if (type == 'submit')
			return function() { self._onsubmit(obj); };
		else
			return function() {}
	},
	_onclick : function(button)
	{
		var self = this;
		if (button.name)
		{
			var object = document.createElement('input');
			object.type = 'hidden';
			object.name = button.name;
			object.value = button.value;
			button.form.appendChild(object);
		}
	},
	_onsubmit : function(form)
	{
		var self = this;
		var elems = form.elements;
		for (var i=0;i<elems.length;i++)
			if (elems[i].type == 'submit') elems[i].disabled = true;
		self.setConfirmationToLeave(false);
	},
	_onleave : function(evnt)
	{
		var self = this;
		if (Spica.FormHandler.instance._ignore) return true;
		evnt = (evnt) ? evnt : ((window.event) ? event : null);
		if ( confirm(Spica.$_('Content has been modified.  Do you want to leave without save?')) )
		{
			window.onbeforeunload = null;
			return true;
		}
		Spica.Event.stop(evnt);
		return false;
	},
	setConfirmationToLeave : function(enable)
	{
		var self = this;
		self._ignore = !enable;
		window.onbeforeunload = (enable) 
			? function() { return Spica.$_('Content has been modified.  Do you want to leave without save?'); } 
			: null;
	}
};
Spica.Event.run(function() { Spica.FormHandler.instance = new Spica.FormHandler });
